#ifndef BLAUMSPECTRA
#define BLAUMSPECTRA
#undef  BLAUMSPECTRADEBUG

#include "BlockCodeGenerator.h"

class BlaumSpectra{
  private:

  int N, K, M, m;
  int *(*T), *(*H);
  int *infoBitsLocation;

  int *tmpCodeWord;
  int *errorPos;

  int *previousTestPattern, *previousOrder;

  int timeCounter, speedup;

  void prsift(double *value, int *p, int k,int i,int l);
  //sorting LeftMost--least of vlaue[], n is the size, sorting k--->m
  //ouptut value[p[]]
  void heapSortLeftLow(double *value, int *p,int n, int k,int m);

  public:

  BlaumSpectra(const BlockCodeGenerator *blockCodeGenerator, int threshWeig);
  ~BlaumSpectra();

  int getAbsSyndrome(int *codeWord);
  void erasureDecoding(int *codeWord, double *codeWordLLR);
  int decodingErasures(int *codeWord, int numNull, double *codeWordLLR);
  int cntHammDist();
  int compare(int k);  // k is the weight of a new-found codeword
  //output minimum-weight codewords to file
  void writeToFile(char *outNameCW, char *outNameSpectra);
  //print minimum-weight codewords
  void print();
  void initTmpDmin();
  void setSpeedupFact(int speedupFactor);

  int absSyndrome;

  int minWeight, tmpMinWeight;
  int threshWeight, *numCodeWordMinWeight;
  int *(*(*codeWordMinWeight)), *(*tmpCWMinWeight);
  //int numOcurrence;
};
#endif





