#define KMAX 8 // max number of rows in the generator matrix
#define NMAX 10 // max number of columns in the generator matrix

#ifndef BLOCKCODEGENERATOR
#define BLOCKCODEGENERATOR

class BlockCodeGenerator {

public:

  // K inputbits generate N outputbits
  int K, N;

  // number of parity checks
  int M;

  // maximum number of ones per row in G and H, respectively
  int l, m;

  // compressed parity check matrix
  int *(*T);

  // compressed generator matrix
  int *(*S);

  // location of info bits within a codeword
  int *infoBitsLocation;

  // construct block code "codeName"
  BlockCodeGenerator(char codeName[100]);

  // destructor
  ~BlockCodeGenerator();

  void printDegSeq(void);

};

#endif



