/**********************************************
 *
 * variable node used in a factor graph
 *
 *******************************************/

#ifndef VARIABLENODE
#define VARIABLENODE

#include "Node.h"

class VariableNode : public Node {

private:

  int size;

public:

  // constructor (has an additional argument compared to the superclass)
  VariableNode(const char *name, int id, int numNeighbours, int size);
  
  // implementation of the inherited abstract method
  virtual void update(int port);

  // implementation of the inherited abstract method
  virtual void reset(void);

  // returns the size of the definition range of this variable
  int getSize(void);

  // inits variable node as first trellis state node in trellis section
  void initAsFirstTrellisState(double *outMessageValues);

  // issues a textual description of the current configuration of this node to standard output
  // (for debugging purposes)
  virtual void draw(void);  

  // issues a textual description of the current configuration of this node to a file
  // (for debugging purposes)
  virtual void draw(FILE *file);  

  // test method
  static void test(void);

};

#endif
